#!/usr/bin/env python

import sys

def prune_equal_header(t1, t2):
	tdiff = []
	while t1 and t2 and t1[0] == t2[0]:
		tdiff.append(" " + t1[0])
		t1.pop(0)
		t2.pop(0)
	return tdiff

def prune_equal_tail(t1, t2):
	tdiff_tail = []
	while t1 and t2 and t1[-1] == t2[-1]:
		tdiff_tail.insert(0, " " + t1[-1])
		t1.pop()
		t2.pop()
	return tdiff_tail

def move_editions(tdiff, sign, source, count):
	for i in range(0, count):
		rec = sign + source.pop(0)
		tdiff.append(rec)

def find_smallest_edition(t1, t2):
	minus = len(t1)
	plus = len(t2)
	cost = minus + plus

	for i in range(0, len(t1)):
		for j in range(0, len(t2)):
			new_cost = i + j
			if new_cost > cost:
				break

			if t1[i] == t2[j]:
				if new_cost < cost:
					cost = new_cost
					minus = i
					plus = j
				break

	return minus, plus

def diff(t1, t2):
	tdiff = []
	tdiff_tail = []

	tdiff_tail = prune_equal_tail(t1, t2)

	while t1 or t2:
		tdiff.extend(prune_equal_header(t1, t2))
		minus, plus = find_smallest_edition(t1, t2)
		move_editions(tdiff, "-", t1, minus)
		move_editions(tdiff, "+", t2, plus)

	for item in tdiff_tail:
		tdiff.append(item)

	return tdiff

t1 = [ x for x in sys.argv[1] ]
t2 = [ x for x in sys.argv[2] ]


tdiff = diff(t1, t2)

for l in tdiff:
	print l,
